A. Winner
time limit per test:1 second
memory limit per test:64 megabytes
input:standard input
output:standard output

The winner of the card game popular in Berland "Berlogging" is determined according to the following rules. If at the end of the game there is only one player with the maximum number of points, he is the winner. The situation becomes more difficult if the number of such players is more than one. During each round a player gains or loses a particular number of points. In the course of the game the number of points is registered in the line "name score", where name is a player's name, and score is the number of points gained in this round, which is an integer number. If score is negative, this means that the player has lost in the round. So, if two or more players have the maximum number of points (say, it equals to m) at the end of the game, than wins the one of them who scored at least m points first. Initially each player has 0 points. It's guaranteed that at the end of the game at least one player has a positive number of points.

Input

The first line contains an integer number n (1  ≤  n  ≤  1000), n is the number of rounds played. Then follow n lines, containing the information about the rounds in "name score" format in chronological order, where name is a string of lower-case Latin letters with the length from 1 to 32, and score is an integer number between -1000 and 1000, inclusive.

Output

Print the name of the winner.

Examples
Input
3 
mike 3
andrew 5
mike 2
Output
andrew
Input
3 
andrew 3
andrew 2
mike 5
Output
andrew

题目链接:http://codeforces.com/problemset/problem/2/A

题意:

给出一些列的名字和分数!正的表示加分,负的表示减分! 求最终分数最大的人的名字;

如果分数最大的人有多个,输出最先达到最大分数的人!

代码如下:

 #include <bits/stdc++.h>
using namespace std;
map<string, int> a,b;
string s[];
int main()
{
int x[];
int n;
cin >> n;
for(int i = ; i <= n; i++)
{
cin >> s[i] >> x[i];
a[s[i]]+=x[i];
}
int maxx = ;
for(int i = ; i <= n; i++)
{
if(a[s[i]] > maxx)
maxx = a[s[i]];
} for(int i = ; i <= n; i++)
{
b[s[i]]+=x[i];
if((b[s[i]]>=maxx) && (a[s[i]]>=maxx))//在最终分数是最大的人中,选首先达到最大分数的人
{
cout << s[i];
break;
}
}
return ;
}
B. The least round way
time limit per test:2 seconds
memory limit per test:64 megabytes
input:standard input
output:standard output

There is a square matrix n × n, consisting of non-negative integer numbers. You should find such a way on it that

  • starts in the upper left cell of the matrix;
  • each following cell is to the right or down from the current cell;
  • the way ends in the bottom right cell.

Moreover, if we multiply together all the numbers along the way, the result should be the least "round". In other words, it should end in the least possible number of zeros.

Input

The first line contains an integer number n (2 ≤ n ≤ 1000), n is the size of the matrix. Then follow n lines containing the matrix elements (non-negative integer numbers not exceeding 109).

Output

In the first line print the least number of trailing zeros. In the second line print the correspondent way itself.

Examples
Input
3 
1 2 3
4 5 6
7 8 9
Output
0 
DDRR

题目链接:http://codeforces.com/problemset/problem/2/B

题目大意

给定一个N*N的格子,每个格子里有一个非负数,要求你找出从左上角到右下角的一条路径,使得它满足路径上的格子里的数全部乘起来的积尾部0最少 题解

如果要产生0肯定是2*5得出来的,最终的乘积可以表示为2^x*5^y*C,那么零的个数就是min(x,y)。我们可以先对每个格子里的数预处理下,计算出2和5的个数来,然后DP分别求出2和5的最小个数然后选两者中的最小值,输出路径方法没啥说的,很传统~~还有一个要注意的问题就是如果某个格子的数字为0的情况,这个需要特殊判断一下,我们可以把它当做10,如果最后的结果0的个数大于1则直接输出尾部0的个数为1即可

下面给出AC代码:

 #include <bits/stdc++.h>
using namespace std;
#define MAXN 1005
#define INF 0x7fffffff
int path[MAXN][MAXN][];
int dp[MAXN][MAXN][],a[MAXN][MAXN][],n;
int zerox,zeroy,x;
string s;
bool flag;
int main()
{
scanf("%d",&n);
flag=false;
for(int i=;i<n;i++)
for(int j=;j<n;j++)
{
scanf("%d",&x);
if(!x)
{
a[i][j][]=a[i][j][]=;
zerox=i,zeroy=j,flag=true;
}
else
{
while(x%==) {a[i][j][]++;x/=;}
while(x%==) {a[i][j][]++,x/=;}
}
}
for(int k=;k<;k++)
for(int i=;i<n;i++)
for(int j=;j<n;j++)
{
int ans=INF;
if(i==&&j==) ans=;
if(i!=&&dp[i-][j][k]<ans) ans=dp[i-][j][k];
if(j!=&&dp[i][j-][k]<ans) ans=dp[i][j-][k],path[i][j][k]=;
dp[i][j][k]=ans+a[i][j][k];
}
int k=dp[n-][n-][]<dp[n-][n-][]?:;
if(flag&&dp[n-][n-][k]>)
{
for(int i=;i<zeroy;i++)
s+="R";
for(int i=;i<zerox;i++)
s+="D";
for(int i=;i<n-zeroy-;i++)
s+="R";
for(int i=;i<n-zerox-;i++)
s+="D";
cout<<<<endl<<s<<endl;
}
else
{
int i=n-,j=n-;
while(i>||j>)
{
if(path[i][j][k]==)
s+="R",j--;
else
s+="D",i--;
}
reverse(s.begin(),s.end());
cout<<dp[n-][n-][k]<<endl<<s<<endl;
}
return ;
}
C. Commentator problem
time limit per test:1 second
memory limit per test:64 megabytes
input:standard input
output:standard output

The Olympic Games in Bercouver are in full swing now. Here everyone has their own objectives: sportsmen compete for medals, and sport commentators compete for more convenient positions to give a running commentary. Today the main sport events take place at three round stadiums, and the commentator's objective is to choose the best point of observation, that is to say the point from where all the three stadiums can be observed. As all the sport competitions are of the same importance, the stadiums should be observed at the same angle. If the number of points meeting the conditions is more than one, the point with the maximum angle of observation is prefered.

Would you, please, help the famous Berland commentator G. Berniev to find the best point of observation. It should be noted, that the stadiums do not hide each other, the commentator can easily see one stadium through the other.

Input

The input data consists of three lines, each of them describes the position of one stadium. The lines have the format x,  y,  r, where (x, y) are the coordinates of the stadium's center ( -  103 ≤ x,  y ≤ 103), and r (1 ≤ r  ≤ 103) is its radius. All the numbers in the input data are integer, stadiums do not have common points, and their centers are not on the same line.

Output

Print the coordinates of the required point with five digits after the decimal point. If there is no answer meeting the conditions, the program shouldn't print anything. The output data should be left blank.

Examples
Input
0 0 10 
60 0 10
30 30 10
Output
30.00000 0.00000

题目链接:http://codeforces.com/problemset/problem/2/C

题目大意:

有3个圆,求一点a,使点a对三个圆的视角相等(过a做圆的两条切线,此两切线的夹角即为视角)。若有多点视角相等,则取视角最大的点。

设三个圆的半径分别为r1,r2,r3。设点a到三个圆的圆心距离分别为d1,d2,d3。

即目标是2*arcsin(r1/d1) = 2*arcsin(r2/d2) = 2*arcsin(r3/d3)。即r1/d1 = r2/d2 = r3/d3

那么这就是解析几何的问题了,就是列出坐标系,一顿算呗。应该很难算。但是算出公式直接给程序就行了。

看到网上还有一种方法,就是一种随机的算法。

从一个初始的解开始逐步逼近最优解。

当迭代了若干步之后,估值函数的值仍然较大时,则不存在解。

最开始,我取的估值函数cost = fabs(ang1-ang2) + fabs(ang2-ang3) + fabs(ang3-ang1). 其中ang1 ang2 ang3就是用arcsin求出来的。

这样的问题就是可能会带来比较大的误差,因为要计算的arcsin的值可能很小,所以一开始一直都没法AC。

后来我把估值函数cost 取为cost = (d1/r1-d2/r2)^2 + (d2/r2-d3/r3)^2 + (d3/r3-d1/r1)^2,效果就好一些,就AC了。

总而言之呢,这种随机算法的题目就是很蛋疼了。但是在蛋疼的基础上,还是可以采取一些办法去减小误差的。

下面给出AC代码:

 #include <bits/stdc++.h>
using namespace std; struct pt {
double x;
double y;
double r;
}; pt mkp(double x, double y) {
pt ret;
ret.x = x;
ret.y = y;
return ret;
} double dis(pt a, pt b) {
return sqrt((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
} double cost(pt *p, double x, double y) {
double ang[];
for (int i = ; i < ; i++) ang[i] = dis(p[i], mkp(x, y)) / p[i].r; double diff[];
for (int i = ; i < ; i++) diff[i] = ang[i] - ang[(i+)%]; double ret = ;
for (int i = ; i < ; i++) ret += diff[i] * diff[i]; return ret;
} const int dx[] = {, , -, };
const int dy[] = {, , , -};
const double err = 1e-;
int main() {
pt p[];
for (int i = ; i < ; i++) scanf("%lf %lf %lf", &(p[i].x), &(p[i].y), &(p[i].r)); pt ans;
ans.x = (p[].x + p[].x + p[].x) / 3.0;
ans.y = (p[].y + p[].y + p[].y) / 3.0;
double ncost = cost(p, ans.x, ans.y); pt tmp;
double step = 1.0;
bool flag = false;
for (int i = ; i < && ncost > err; i++) {
flag = false;
for (int k = ; k < ; k++) {
tmp.x = ans.x + step * ((double)dx[k]);
tmp.y = ans.y + step * ((double)dy[k]); if (ncost > cost(p, tmp.x, tmp.y)) {
ncost = cost(p, tmp.x, tmp.y);
ans = tmp;
flag = true;
}
}
if (!flag) step *= 0.5;
} if (cost(p, ans.x, ans.y) <= err) printf("%.5lf %.5lf\n", ans.x, ans.y);
return ;
}

Codeforces Beta Round #2 A,B,C的更多相关文章

  1. Codeforces Beta Round #80 (Div. 2 Only)【ABCD】

    Codeforces Beta Round #80 (Div. 2 Only) A Blackjack1 题意 一共52张扑克,A代表1或者11,2-10表示自己的数字,其他都表示10 现在你已经有一 ...

  2. Codeforces Beta Round #62 题解【ABCD】

    Codeforces Beta Round #62 A Irrational problem 题意 f(x) = x mod p1 mod p2 mod p3 mod p4 问你[a,b]中有多少个数 ...

  3. Codeforces Beta Round #83 (Div. 1 Only)题解【ABCD】

    Codeforces Beta Round #83 (Div. 1 Only) A. Dorm Water Supply 题意 给你一个n点m边的图,保证每个点的入度和出度最多为1 如果这个点入度为0 ...

  4. Codeforces Beta Round #13 C. Sequence (DP)

    题目大意 给一个数列,长度不超过 5000,每次可以将其中的一个数加 1 或者减 1,问,最少需要多少次操作,才能使得这个数列单调不降 数列中每个数为 -109-109 中的一个数 做法分析 先这样考 ...

  5. Codeforces Beta Round #79 (Div. 2 Only)

    Codeforces Beta Round #79 (Div. 2 Only) http://codeforces.com/contest/102 A #include<bits/stdc++. ...

  6. Codeforces Beta Round #77 (Div. 2 Only)

    Codeforces Beta Round #77 (Div. 2 Only) http://codeforces.com/contest/96 A #include<bits/stdc++.h ...

  7. Codeforces Beta Round #76 (Div. 2 Only)

    Codeforces Beta Round #76 (Div. 2 Only) http://codeforces.com/contest/94 A #include<bits/stdc++.h ...

  8. Codeforces Beta Round #75 (Div. 2 Only)

    Codeforces Beta Round #75 (Div. 2 Only) http://codeforces.com/contest/92 A #include<iostream> ...

  9. Codeforces Beta Round #74 (Div. 2 Only)

    Codeforces Beta Round #74 (Div. 2 Only) http://codeforces.com/contest/90 A #include<iostream> ...

  10. Codeforces Beta Round #73 (Div. 2 Only)

    Codeforces Beta Round #73 (Div. 2 Only) http://codeforces.com/contest/88 A 模拟 #include<bits/stdc+ ...

随机推荐

  1. 【python】函数说明文档

  2. ios单独的页面支持横竖屏的状态调整,HTML5加载下(更新2)

    单独的页面支持横竖屏的状态调整,HTML5加载下 工程中设置只支持竖屏状态,在加载HTML5的界面可以是横竖屏的,在不对工程其他界面/设置做调整的同时,可以这样去 #import "View ...

  3. lua元方法

    lua中有元表的概念,元表类似于基类的功能, 在元表中有两个方法可以很好的认识元表: __index和__newindex __index用于查询 对表中的字段进行访问时,如果该表有元表,并且 表中没 ...

  4. HashMap 之弱引用 - WeakHashMap

    ■ Java 引用的相关知识 1. 强引用 Object o = new Object(); 强引用是Java 默认实现 的引用,JVM会尽可能长时间的保留强引用的存在(直到内存溢出) 当内存空间不足 ...

  5. 扩展1 - Python 获取当前时间的用法

    1.先导入库:import datetime 2.获取当前日期和时间:now_time = datetime.datetime.now() 3.格式化成我们想要的日期:strftime() 比如:“2 ...

  6. application19事件 20多少步骤 具体20多少只有微软知道!!!

  7. Linux_服务器_07_ 将用户设置为管理员

    二.参考资料 1.CentOS普通用户获得管理员权限 2.linux下添加用户并赋予root权限

  8. Android java.io.FileNotFoundException:*** (Permission denied)

    自从离开上海来到杭州之后,陆续接触了Android,Python,C++,OpenCV,最为一个新人来说,一路上遇到了很多坑,幸运的是 这互联网的强大(大傻子我还是蛮喜欢的哈),一路填填补补总算走了下 ...

  9. python2中的__init__.py文件的作用

    python2中的__init__.py文件的作用: 1.python的每个模块的包中,都必须有一个__init__.py文件,有了这个文件,我们才能导入这个目录下的module. 2.__init_ ...

  10. grpc

    grpc入门(二) 一. 目标 本博文要介绍的是编写 grpc入门(一)中所提到的四种rpc的方式,然后通过命令行和eclipse两种方式生成对应的java代码,关于grpc是什么东西本文不再赘述. ...